function demoFolgeregelung (varargin)
%DEMOFOLGEREGELUNG - Diese Funktion fhrt eine GUI aus, welche durch die
% Demo einer Folgeregelung fhrt. 
%
% Autor:  Matthias Schwaiger, Martin Pfeifer, Jona Maurer
% Insitut fr Regelung und Steurungssysteme (IRS)
% Karlsruher Institut fr Technologie
% E-mail: jona.maurer@kit.edu 
% Website: http://www.irs.kit.edu
% Dezember 2005; Letzte nderung: 2-Mai-2016

%------------- BEGIN CODE --------------

%%%%%%%%%%%%%%%%%%%%%%%%%
%%%                   %%% 
%%%   Einstellungen   %%%
%%%                   %%% 
%%%%%%%%%%%%%%%%%%%%%%%%%

%%% Befehl zur Initialisierung der Demo
init='';

%%% Titel des Fensters
titel='ORS > Demo 2: Riccati-Folge-Regler';

%%% Knopfdimensionen und -abstnde
buttonbreite=300;
buttonhoehe=40;
buttonxabstand=15;
buttonyabstand=20;

%%% Einstellungen fr die Knpfe:
%%% button(x,y).text      (angezeigter Text)
%%% button(x,y).befehl    (auszufhrender Befehl)
%%% button(x,y).tooltip   (Text beim drberfahren des Mauszeigers)
%%% button(x,y).kommentar (Text, der am Matlabprompt beim Ausfhren angezeigt wird)

button(1,1).text='Verhalten des offenen Kreises';
button(1,1).befehl='ors_ungeregelt;';

button(1,2).text='Offener Kreis mit Strung';
button(1,2).befehl='ors_ungeregelt_stoerung;';

button(2,1).text='Riccati-Folge-Regler';
button(2,1).befehl='ors_riccati;';

button(2,2).text='Riccati-Folge-Regler mit Strung';
button(2,2).befehl='ors_riccati_stoerung;';

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%                                                %%%
%%%   AB HIER MUSS NICHTS MEHR VERNDERT WERDEN!   %%%
%%%                                                %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if nargin == 0
    if ~isempty(findobj('tag','demofenster'))
        close(findobj('tag','demofenster'));
    end

    fig=figure;
    scr=get(0,'Screensize');
    set(fig,'position',[4 scr(4)-22-(size(button,1)*buttonhoehe+(size(button,1)+1)*buttonyabstand) (size(button,2)*buttonbreite+(size(button,2)+1)*buttonxabstand) (size(button,1)*buttonhoehe+(size(button,1)+1)*buttonyabstand)], ...
        'menubar','none','numbertitle','off','resize','off','tag','demofenster','name',titel);
    for k=1:size(button,1)
        for m=1:size(button,2)
            if ~isempty(button(k,m).befehl)
                knopf=uicontrol(fig,'units','pixels','position',[buttonxabstand+((m-1)*(buttonxabstand+buttonbreite)) buttonyabstand+((size(button,1)-k)*(buttonyabstand+buttonhoehe)) buttonbreite buttonhoehe],...
                    'style','pushbutton','callback',[mfilename '(' num2str(k) ',' num2str(m) ')']);
                eval('set(knopf,''string'',button(k,m).text)','');
                eval('set(knopf,''tooltipstring'',button(k,m).tooltip)','');
            end
        end
    end
    eval(init,'disp([''Der Befehl '' init '' kann nicht ausgefhrt werden!'']);');
else
    if nargin == 1
        spalte=1;
    else
        spalte=varargin{2};
    end
    daten=get(gcf,'Userdata');
    eval('disp(button(varargin{1},spalte).kommentar);','');
    eval(button(varargin{1},spalte).befehl,'disp([''Der Befehl '' button(varargin{1},spalte).befehl '' kann nicht ausgefhrt werden!'']);');
end
