function ors_plot_trajektorien (zeit,x1,x2,u,legende)

graph.textsize = 12;
graph.linesize = 1;
graph.farbe  = {'b','r','m','k','g','c','y'};	%Linienfarben
graph.marker = {'*','+','s','d'};
graph.linie  = {'-',':','-.','--'};

if isempty(findobj('Tag',mfilename))
    scr=get(0,'Screensize');
    fig = figure('NumberTitle','off','Name','Vergleich der Trajektorien','Tag',mfilename, ...
        'menubar','none');
    set(fig,'position',[4 35 scr(3)-8 scr(4)-80]);
    daten.legendentext=[];
    daten.plotwerte=[];
    daten.plotprops.min=[nan nan nan];
    daten.plotprops.max=[nan nan nan];
else
    figure(findobj('Tag',mfilename));
    daten=get(findobj('Tag',mfilename),'userdata');
end;

datensatz=length(daten.plotwerte)+1;

daten.plotwerte{datensatz}.zeit=zeit;
daten.plotwerte{datensatz}.x1=x1;
daten.plotwerte{datensatz}.x2=x2;
daten.plotwerte{datensatz}.u=u;
daten.legendentext{datensatz}=legende;

daten.plotprops.min = min([daten.plotprops.min; [min(x1) min(x2) min(u)]]);
daten.plotprops.max = max([daten.plotprops.max; [max(x1) max(x2) max(u)]]);

subplot(3,1,1)
plot(zeit,x1, ...
    [graph.farbe{mod(datensatz-1,length(graph.farbe))+1},graph.linie{min(floor((datensatz-1)/length(graph.farbe))+1,length(graph.linie))}], ...
    'LineWidth',graph.linesize);
ylim([daten.plotprops.min(1), daten.plotprops.max(1)]+[-1 1]*max(0.01,0.05*(daten.plotprops.max(1)-daten.plotprops.min(1))));
set(gca,'LineWidth',graph.linesize,'Fontsize',graph.textsize)
title('Riccati-Regler','FontSize',graph.textsize)
ylabel('x_1','FontSize',graph.textsize)
% legend(daten.legendentext,1)
zoom on
hold on
grid on

subplot(3,1,2)
plot(zeit,x2, ...
    [graph.farbe{mod(datensatz-1,length(graph.farbe))+1},graph.linie{min(floor((datensatz-1)/length(graph.farbe))+1,length(graph.linie))}], ...
    'LineWidth',graph.linesize);
ylim([daten.plotprops.min(2), daten.plotprops.max(2)]+[-1 1]*max(0.01,0.05*(daten.plotprops.max(2)-daten.plotprops.min(2))));
set(gca,'LineWidth',graph.linesize,'Fontsize',graph.textsize)
ylabel('x_2','FontSize',graph.textsize)
% legend(daten.legendentext,1)
zoom on
hold on
grid on

subplot(3,1,3)
plot(zeit,u, ...
    [graph.farbe{mod(datensatz-1,length(graph.farbe))+1},graph.linie{min(floor((datensatz-1)/length(graph.farbe))+1,length(graph.linie))}], ...
    'LineWidth',graph.linesize);
ylim([daten.plotprops.min(3), daten.plotprops.max(3)]+[-1 1]*max(0.01,0.05*(daten.plotprops.max(3)-daten.plotprops.min(3))));
set(gca,'LineWidth',graph.linesize,'Fontsize',graph.textsize)
ylabel('u','FontSize',graph.textsize)
xlabel('Zeit ','FontSize',graph.textsize)
legend(daten.legendentext,1)
zoom on
hold on
grid on

set(findobj('Tag',mfilename),'userdata',daten);

