function ors_riccati(varargin)

if nargin > 0
    ors_riccati_cb(varargin{1});
    return
end

% Beim ersten Aufruf muss erst einmal das Bild aufgebaut werden und die
% verschiedenen Elemente, wie z.B. die Plots platziert werden.
if ~isempty(findobj('tag',mfilename))
    close(findobj('tag',mfilename));
end
fig=figure;
scr=get(0,'Screensize');
set(fig,'position',[4 35 scr(3)-8 scr(4)-80],'tag',mfilename, ...
    'NumberTitle','off','Name','Zeitinvarianter Riccati-Folge-Regler','menubar','none');

% Feld fr T_max
data.feld(1)=uicontrol(fig,'units','normalized','position',[0.05 0.885 0.05 0.03],'style','text', ...
    'Horizontalalignment','left','string','Q:','backgroundcolor',get(gcf,'color'),...
    'fontsize',14);
data.feld(2)=uicontrol(fig,'units','normalized','position',[0.10 0.91 0.10 0.04],'style','edit', ...
    'callback',[mfilename '(2)'],'fontsize',14);
data.feld(3)=uicontrol(fig,'units','normalized','position',[0.22 0.91 0.10 0.04],'style','edit', ...
    'callback',[mfilename '(3)'],'fontsize',14);
data.feld(4)=uicontrol(fig,'units','normalized','position',[0.10 0.85 0.10 0.04],'style','edit', ...
    'callback',[mfilename '(4)'],'fontsize',14);
data.feld(5)=uicontrol(fig,'units','normalized','position',[0.22 0.85 0.10 0.04],'style','edit', ...
    'callback',[mfilename '(5)'],'fontsize',14);

data.feld(6)=uicontrol(fig,'units','normalized','position',[0.40 0.885 0.05 0.03],'style','text', ...
    'Horizontalalignment','left','string','r:','backgroundcolor',get(gcf,'color'),...
    'fontsize',14);
data.feld(7)=uicontrol(fig,'units','normalized','position',[0.45 0.88 0.10 0.04],'style','edit', ...
    'callback',[mfilename '(7)'],'fontsize',14);

% Informationsfenster platzieren
data.info1=uicontrol(fig,'units','normalized','position',[0.05 0.15 0.9 0.65], ...
    'style','text','fontsize',20,'fontname','fixedwidth','fontweight','bold','Horizontalalignment','left', ...
    'backgroundcolor',[0.95 0.95 0.95]);

% Buttons fr Simulationsfenster und Simulation
data.button(1)=uicontrol(fig,'units','normalized','position',[0.7 0.03 0.25 0.05],'style','pushbutton', ...
    'string','System simulieren','tag','forw','callback',[mfilename '(11)'],'fontsize',14);
data.button(2)=uicontrol(fig,'units','normalized','position',[0.425 0.03 0.25 0.05],'style','pushbutton', ...
    'callback',[mfilename '(12)'],'string','Simulink-Modell ffnen','tag','simulink','fontsize',14);
data.button(3)=uicontrol(fig,'units','normalized','position',[0.7 0.875 0.25 0.05],'style','pushbutton', ...
    'string','Regler berechnen','tag','forw','callback',[mfilename '(10)'],'fontsize',14);

set(fig,'userdata',data);
eval([mfilename '(0);'],'lasterr');
return

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function ors_riccati_cb(choice)

if isempty(findobj('tag','ors_riccati'))
    return;
else
    fig=findobj('tag','ors_riccati');
    figure(fig);
end

daten=get(fig,'userdata');

if choice == 0
    daten.A=[0 1; 2 -1];
    daten.B=[0; 1];
    daten.Q=[1 0; 0 1];
    daten.r=[1];
    daten.k = [];
    daten.P = [];
    set(daten.feld(2),'string',num2str(daten.Q(1,1)));
    set(daten.feld(3),'string',num2str(daten.Q(1,2)));
    set(daten.feld(4),'string',num2str(daten.Q(2,1)));
    set(daten.feld(5),'string',num2str(daten.Q(2,2)));
    set(daten.feld(7),'string',num2str(daten.r));
    set(fig,'userdata',daten);
end

if choice == 2 % Eingabe von q11
    daten.Q(1,1)=wert_korrigieren(get(daten.feld(2),'string'));
    set(daten.feld(2),'string',num2str(daten.Q(1,1)));
    set(fig,'userdata',daten);
end

if choice == 3 % Eingabe von q12, q21
    daten.Q(1,2)=wert_korrigieren(get(daten.feld(3),'string'));
    daten.Q(2,1)=daten.Q(1,2);
    set(daten.feld(3),'string',num2str(daten.Q(1,2)));
    set(daten.feld(4),'string',num2str(daten.Q(2,1)));
    set(fig,'userdata',daten);
end

if choice == 4 % Eingabe von q12, q21
    daten.Q(2,1)=wert_korrigieren(get(daten.feld(4),'string'));
    daten.Q(1,2)=daten.Q(2,1);
    set(daten.feld(3),'string',num2str(daten.Q(1,2)));
    set(daten.feld(4),'string',num2str(daten.Q(2,1)));
    set(fig,'userdata',daten);
end

if choice == 5 % Eingabe von q22
    daten.Q(2,2)=wert_korrigieren(get(daten.feld(5),'string'));
    set(daten.feld(5),'string',num2str(daten.Q(2,2)));
    set(fig,'userdata',daten);
end

if choice == 7 % Eingabe von r
    daten.r=wert_korrigieren(get(daten.feld(7),'string'));
    set(daten.feld(7),'string',num2str(daten.r));
    set(fig,'userdata',daten);
end

if (choice >= 2) & (choice <= 7) % Berechnung
    daten.k = [];
    daten.P = [];
    fehler = 0;
    string = [char(10) ' Determinante der Matrix Q: ' num2str(det(daten.Q))];
    if ( (det(daten.Q) == 0) | (min(eig(daten.Q)) < 0)  )
        string = [string char(10) char(10) ' Fehler: Matrix Q ist nicht positiv definit!'];
        fehler = 1;
    end
    if ( daten.r <= 0)
        string = [string char(10) char(10) ' Fehler: r ist nicht positiv!'];
        fehler = 1;
    end
    set(daten.info1,'visible','on','string', string,'foregroundcolor',[0 0 0]);
    if fehler
        set(daten.info1,'foregroundcolor',[1 0 0]);
    end
    set(fig,'userdata',daten);
end

if choice == 10 % Regler berechnen
    if (det(daten.Q) ~= 0) & (min(eig(daten.Q)) >= 0) & ( daten.r > 0)
        [daten.k,daten.P] = lqr2(daten.A,daten.B,daten.Q,daten.r);
        set(daten.info1,'visible','on','string', [char(10) ...
            ' Matrix P:' char(10) char(10) ...
            '         ' char(10) ...
            '         ' num2str(daten.P(1,1)) '   ' num2str(daten.P(1,2)) '' char(10) ...
            '    P =        ' char(10) ...
            '         ' num2str(daten.P(2,1)) '   ' num2str(daten.P(2,2)) '' char(10) char(10) ...
            ' Reglerverstrkung k:' char(10) char(10) ...
            '        ' char(10) ...
            '    k = ' num2str(daten.k(1)) '   ' num2str(daten.k(2)) '' char(10) char(10) ...
            ' (aus der Matrix-Riccati-Gleichung)' char(10) ], ...
                    'foregroundcolor',[0 0 0]);
    else
        set(daten.info1,'visible','on','string', ...
                    [char(10) ' Fehler in Matrix Q und/oder Vektor r!'], ...
                    'foregroundcolor',[1 0 0]);
    end
    set(fig,'userdata',daten);
end

if choice == 11 % Simulation starten
    if any(size(daten.k(:)) ~= [2 1])
        set(daten.info1,'visible','on','string', ...
                    [char(10) ' Reglerverstrkung k wurde noch nicht berechnet!'], ...
                    'foregroundcolor',[1 0 0]);
    else
        assignin('base','k',daten.k);
        sim('ors_lq_folgeregler_1.mdl');
        
        plotsollwerte=1;
        if ~isempty(findobj('Tag','ors_plot_trajektorien'))
            plotdaten=get(findobj('Tag','ors_plot_trajektorien'),'userdata');
            for k=1:length(plotdaten.legendentext)
                if strcmp('Sollwerte',plotdaten.legendentext{k})
                    plotsollwerte=0;
                end
            end
        end
        if plotsollwerte
            legende=['Sollwerte'];
            ors_plot_trajektorien (simout.time,simout.signals.values(:,4),...
                simout.signals.values(:,5),...
                simout.signals.values(:,6),...
                legende);
        end
        legende=['Folgeregler: Q = [' num2str(daten.Q(1,1)) ' ' num2str(daten.Q(1,2)) '; ' ...
            num2str(daten.Q(2,1)) ' ' num2str(daten.Q(2,2)) ']; r = ' num2str(daten.r)];
        ors_plot_trajektorien (simout.time,simout.signals.values(:,1),...
            simout.signals.values(:,2),...
            simout.signals.values(:,3),...
            legende);
    end
end

if choice == 12 % Simulink-Moell ffnen
    open_system('ors_lq_folgeregler_1.mdl');
end

return

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function out=wert_korrigieren(in)

in(findstr(in,','))='.';
temp=findstr(in,'.');
if length(temp)>1
    in(temp(2):end)='';
end
out=str2num(in);
out=out(1,1);
if isempty(out)
    out=0;
end



