function ors_ungeregelt_stoerung(varargin)

% Demo in ORS

if nargin == 0
    % Beim ersten Aufruf muss erst einmal das Bild aufgebaut werden und die
    % verschiedenen Elemente, wie z.B. die Plots platziert werden.
    if ~isempty(findobj('tag',mfilename))
        close(findobj('tag',mfilename));
    end
    fig=figure;
    scr=get(0,'Screensize');
    set(fig,'position',[4 35 scr(3)-8 scr(4)-80],'tag',mfilename, ...
        'NumberTitle','off','Name','Riccati-Folgeregler: ungeregeltes System mit Strung','menubar','none');

    % Informationsfenster platzieren
    data.info1=uicontrol(fig,'units','normalized','position',[0.05 0.15 0.9 0.8], ...
        'style','text','fontsize',20,'fontname','fixedwidth','fontweight','bold','Horizontalalignment','left', ...
        'backgroundcolor',[0.95 0.95 0.95]);

    % Buttons fr Simulationsfenster und Simulation
    data.sim=uicontrol(fig,'units','normalized','position',[0.7 0.03 0.25 0.05],'style','pushbutton', ...
        'string','System simulieren','tag','forw','callback',[mfilename '(2)'],'fontsize',14);
    data.simulink=uicontrol(fig,'units','normalized','position',[0.425 0.03 0.25 0.05],'style','pushbutton', ...
        'callback',[mfilename '(3)'],'string','Simulink-Modell ffnen','tag','simulink','fontsize',14);
    
    set(fig,'userdata',data);
    eval([mfilename '(1);'],'lasterr');
    return
else
    % Das Bild wurde bereits aufgebaut und jetzt mssen die
    % Aktionen ausgefhrt werden, die beim Klicken auf die Bedienelemente
    % erfolgen sollen.

    if isempty(findobj('tag',mfilename))
        return; % Sicherheitsabfrage, falls figure geschlossen
    end
    fig=findobj('tag',mfilename);
    figure(fig);
    % Die im Bild gespeicherten Daten auslesen
    data=get(fig,'userdata');
    %daten=data.daten;

    switch varargin{1}
        case 1
            set(data.info1,'visible','on','string', ...
                [ ...
                ' Systemgleichungen:' char(10) char(10) ...
                '    x1_p = x2' char(10) ...
                '    x2_p = 2*x1 - x2 + u' char(10) char(10) ...
                ' Systemmatrix; Eingangsvektor:' char(10) ...
                '         _     _          _   _' char(10) ...
                '        | 0   1 |        |  0  |' char(10) ...
                '    A = |       | ;  b = |     |' char(10) ...
                '        |_2  -1_|        |_ 1 _|' char(10) char(10)  ...
                ' Sollgroessenvorgabe:' char(10) char(10) ...
                '    x1s = 0.2 * t + 0.2' char(10) ...
                '    x2s = 0.4' char(10) ...
                '    us = -0.4 * t + 0.2 = -2 * x1s + 1.5 * x2s' char(10) ...
                '    z = [0.2 ; 0.2]^T' char(10) ...
                ]);
        case 2
            assignin('base','k',[0 0]); %offener Kreis
            assignin('base','k_s',0); %Strgrenaufschaltung
            sim('ors_lq_folgeregler_2.mdl');
            %simout=evalin('base','simout');
            ors_plot_trajektorien (simout.time,simout.signals.values(:,1),...
                simout.signals.values(:,2),...
                simout.signals.values(:,3),...
                'offener Kreis mit Strung');
        case 3
            open_system('ors_lq_folgeregler_2.mdl');
    end
end

















